#!/bin/sh

# Script to upgrade Debian Squeeze to Wheezy

# Update current OS
apt-get update
apt-get upgrade -y
apt-get dist-upgrade
apt-get clean

df -h
echo -e 'If diskspace is 4Gb with prod/test sites, you may have issues. Press y to continue or any other key to break.'
read confirm
if [ "$confirm" != "y" ]; then
    exit 1
fi

# 
dpkg --audit
dpkg --get-selections | grep hold

echo -e 'The above 2 should give no results. Press y to continue or any other key to break.'
read confirm
if [ "$confirm" != "y" ]; then
    exit 1
fi

echo -e 'We should see "No packages are scheduled to be installed, removed or upgraded"'
echo -e 'Use - to deselect any which are being requested'
echo -e 'g then q to exit'

aptitude

echo -e 'Press y to continue or any other key to break.'
read confirm
if [ "$confirm" != "y" ]; then
    exit 1
fi

# Update Sources
cat << EOF > "/etc/apt/sources.list"
deb     http://http.debian.net/debian wheezy         main
deb-src http://http.debian.net/debian wheezy         main
deb     http://security.debian.org/   wheezy/updates main
deb-src http://security.debian.org/   wheezy/updates main
EOF
apt-get update
apt-get upgrade
apt-get clean
apt-get dist-upgrade
apt-get clean
# Can't do this for Apache servers as mod_wsgi depends still (despite running 2.7.3 fine!)
apt-get remove -y python2.6-dev python2.6 python2.6-minimal python-shapely
sudo aptitude purge `dpkg --get-selections | grep deinstall | awk '{print $1}'`

echo 'After reboot, run part2'
reboot

# END
