#!/bin/sh

# Script to upgrade Debian Squeeze to Wheezy
# Part 2 - after Reboot

cd /tmp
apt-get install -y libgeos-dev
wget http://pypi.python.org/packages/source/S/Shapely/Shapely-1.2.18.tar.gz
tar zxvf Shapely-1.2.18.tar.gz
cd Shapely-1.2.18
python setup.py install
cd ..
wget http://projects.unbit.it/downloads/uwsgi-1.2.6.tar.gz
tar zxvf uwsgi-1.2.6.tar.gz
cd uwsgi-1.2.6/buildconf
wget http://eden.sahanafoundation.org/downloads/uwsgi_build.ini
cd ..
sed -i "s|, '-Werror'||" uwsgiconfig.py
python uwsgiconfig.py --build uwsgi_build
/etc/init.d/uwsgi stop
/etc/init.d/uwsgi-prod stop
/etc/init.d/uwsgi-test stop
cp uwsgi /usr/local/bin
rm -rf /home/web2py/eden/compiled/
compile
compile prod
rm -rf /home/test/eden/compiled/
compile test
reboot

# PostgreSQL
apt-get install -y postgresql-9.1-postgis
apt-get clean
/etc/init.d/uwsgi stop
/etc/init.d/uwsgi-prod stop
/etc/init.d/uwsgi-demo stop
/etc/init.d/uwsgi-test stop
su postgres
pg_dropcluster --stop 9.1 main    
pg_upgradecluster 8.4 main
/etc/init.d/uwsgi start
/etc/init.d/uwsgi-prod start

# Upgrade management scripts
sed -i 's/8.4/9.1/g' /usr/local/bin/clean
sed -i 's/su -c - postgres "createlang plpgsql/#su -c - postgres "createlang plpgsql/g' /usr/local/bin/clean

cat << EOF > "/usr/local/bin/pg1024"
#!/bin/sh
sed -i 's|kernel.shmmax = 279134208|#kernel.shmmax = 279134208|' /etc/sysctl.conf
sed -i 's|#kernel.shmmax = 552992768|kernel.shmmax = 552992768|' /etc/sysctl.conf
sysctl -w kernel.shmmax=552992768
sed -i 's|shared_buffers = 56MB|shared_buffers = 160MB|' /etc/postgresql/9.1/main/postgresql.conf
sed -i 's|effective_cache_size = 256MB|effective_cache_size = 512MB|' /etc/postgresql/9.1/main/postgresql.conf
sed -i 's|work_mem = 2MB|work_mem = 4MB|' /etc/postgresql/9.1/main/postgresql.conf
/etc/init.d/postgresql restart
EOF
chmod +x /usr/local/bin/pg1024

cat << EOF > "/usr/local/bin/pg512"
#!/bin/sh
sed -i 's|#kernel.shmmax = 279134208|kernel.shmmax = 279134208|' /etc/sysctl.conf
sed -i 's|kernel.shmmax = 552992768|#kernel.shmmax = 552992768|' /etc/sysctl.conf
sysctl -w kernel.shmmax=279134208
sed -i 's|shared_buffers = 160MB|shared_buffers = 56MB|' /etc/postgresql/9.1/main/postgresql.conf
sed -i 's|effective_cache_size = 512MB|effective_cache_size = 256MB|' /etc/postgresql/9.1/main/postgresql.conf
sed -i 's|work_mem = 4MB|work_mem = 2MB|' /etc/postgresql/9.1/main/postgresql.conf
/etc/init.d/postgresql restart
EOF
chmod +x /usr/local/bin/pg512

pg_dropcluster 8.4 main
apt-get remove -y postgresql-8.4 postgresql-client-8.4 postgresql-8.4-postgis libgeos-3.2.0

echo 'Now run pg512 or pg1024, as-appropriate for your RAM'

# END
